//---------------------------------------------------------------------------------
//
// Autogenerated from CreateDllWrapper.pl
//
// Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia.
// All Rights Reserved.
//
//---------------------------------------------------------------------------------

#ifndef TA_COLLISION_WRAPPER_H
#define TA_COLLISION_WRAPPER_H

#include "../Common/Types.h"

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

enum
{
	TA_COLLISION_FLAG_CONSTRAIN_IN_BOTH_DIRECTIONS =		0x1,
	TA_COLLISION_FLAG_FRICTION =							0x2,
	TA_COLLISION_FLAG_FRICTION_GENERATING_IMPULSE =		0x4,
	TA_COLLISION_FLAG_NO_FRICTION =						0x8,
	TA_COLLISION_FLAG_JOINT =							0x10,
	TA_COLLISION_FLAG_JOINT_LIMIT =						0x20,
	TA_COLLISION_FLAG_COLLISION_OCCURRED =				0x40,
	TA_COLLISION_FLAG_DISABLE_PUSHOUT =					0x80,
	TA_COLLISION_FLAG_MARKED =							0x200,
	TA_COLLISION_FLAG_RESTITUTION_CALCULATED =			0x400,
	TA_COLLISION_FLAG_OBJECTA_SOLID = 					0x1000,
	TA_COLLISION_FLAG_OBJECTB_SOLID = 					0x2000,
	TA_COLLISION_FLAG_NEW_COLLISION = 					0x4000,
	TA_COLLISION_FLAG_ROTATION_CONSTRAINT =				0x8000,
	TA_COLLISION_FLAG_OBJECTB_INFINITE_MASS =			0x10000,
	TA_COLLISION_FLAG_DEPTH_CALCULATED_FROM_TIME =		0x20000,
	TA_COLLISION_FLAG_USE_PUSH_OUT_MODIFIER =			0x40000,
};

TA_EXPORT void TA_CALL TaCollision_Clear(
	TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_Initialise(
	TaCollision* pTaCollision,
	TaDynamicObject* pNewObjectA,
	TaDynamicObject* pNewObjectB,
	float fNewTime,
	float fNewIntersectingDepth,
	const TaVec3* v3NewPosition,
	const TaVec3* v3NewNormal);

TA_EXPORT const TaVec3* TA_CALL TaCollision_GetPosition(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetPosition(
	TaCollision* pTaCollision,
	const TaVec3* v3Position);

TA_EXPORT const TaVec3* TA_CALL TaCollision_GetNormal(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetNormal(
	TaCollision* pTaCollision,
	const TaVec3* v3Normal);

TA_EXPORT TaDynamicObject* TA_CALL TaCollision_GetObjectA(
	const TaCollision* pTaCollision);

TA_EXPORT TaDynamicObject* TA_CALL TaCollision_GetObjectB(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetObjectA(
	TaCollision* pTaCollision,
	TaDynamicObject* pDynamicObject);

TA_EXPORT void TA_CALL TaCollision_SetObjectB(
	TaCollision* pTaCollision,
	TaDynamicObject* pDynamicObject);

TA_EXPORT TaCollisionObject* TA_CALL TaCollision_GetCollisionObjectA(
	TaCollision* pTaCollision);

TA_EXPORT TaCollisionObject* TA_CALL TaCollision_GetCollisionObjectB(
	TaCollision* pTaCollision);

TA_EXPORT const TaCollisionObject* TA_CALL TaCollision_GetCollisionObjectA2(
	const TaCollision* pTaCollision);

TA_EXPORT const TaCollisionObject* TA_CALL TaCollision_GetCollisionObjectB2(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetCollisionObjectA(
	TaCollision* pTaCollision,
	TaCollisionObject* pCollisionObjectA);

TA_EXPORT void TA_CALL TaCollision_SetCollisionObjectB(
	TaCollision* pTaCollision,
	TaCollisionObject* pCollisionObjectB);

TA_EXPORT int TA_CALL TaCollision_GetFlags(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetFlags(
	TaCollision* pTaCollision,
	ta_u32 nFlags);

TA_EXPORT ta_u32* TA_CALL TaCollision_Flags(
	TaCollision* pTaCollision);

TA_EXPORT float TA_CALL TaCollision_GetRestitution(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetRestitution(
	TaCollision* pTaCollision,
	float fRestitution);

TA_EXPORT float TA_CALL TaCollision_GetImpulse(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetImpulse(
	TaCollision* pTaCollision,
	float fImpulse);

TA_EXPORT float TA_CALL TaCollision_GetFrictionCoefficient(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetFrictionCoefficient(
	TaCollision* pTaCollision,
	float fFrictionCoefficient);

TA_EXPORT float TA_CALL TaCollision_GetTime(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetTime(
	TaCollision* pTaCollision,
	float fTime);

TA_EXPORT float TA_CALL TaCollision_GetIntersectingDepth(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetIntersectingDepth(
	TaCollision* pTaCollision,
	float fIntersectingDepth);

TA_EXPORT ta_u32 TA_CALL TaCollision_GetCollisionIdA(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetCollisionIdA(
	TaCollision* pTaCollision,
	ta_u32 nCollisionIdA);

TA_EXPORT ta_u32 TA_CALL TaCollision_GetCollisionIdB(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetCollisionIdB(
	TaCollision* pTaCollision,
	ta_u32 nCollisionIdB);

TA_EXPORT ta_u32 TA_CALL TaCollision_GetAttributeA(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetAttributeA(
	TaCollision* pTaCollision,
	ta_u32 nAttributeA);

TA_EXPORT ta_u32 TA_CALL TaCollision_GetAttributeB(
	const TaCollision* pTaCollision);

TA_EXPORT void TA_CALL TaCollision_SetAttributeB(
	TaCollision* pTaCollision,
	ta_u32 nAttributeB);

TA_EXPORT TaPhysicsJoint* TA_CALL TaCollision_GetJoint(
	TaCollision* pTaCollision);

TA_EXPORT const TaPhysicsJoint* TA_CALL TaCollision_GetJoint2(
	const TaCollision* pTaCollision);

TA_EXPORT TaBool TA_CALL TaCollision_CollisionOccurred(
	const TaCollision* pTaCollision);

TA_EXPORT TaCollision* TA_CALL TaCollision_GetNext(
	TaCollision* pTaCollision);

#ifdef __cplusplus
} // extern "C"
#endif // __cplusplus

#if defined(__cplusplus) && !defined(TA_C_IMPLEMENTATION)
#include "Collision.hpp"
#endif // defined(__cplusplus) && !defined(TA_C_IMPLEMENTATION)

#endif // TA_COLLISIONWRAPPER_H
