{

 Autogenerated from CreateDllWrapper.pl

 Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia.
 All Rights Reserved.

}

unit TaPhysics;

interface

uses TaTypes;

const
	TA_PHYSICS_FLAG_DYNAMIC_OBJECTS : Integer = $1; 
	TA_PHYSICS_FLAG_STATIC_OBJECTS : Integer = $2; 
	 
	TA_PHYSICS_FLAG_ALL_OBJECTS : Integer = $1 + $2; 
	TA_PHYSICS_FLAG_ALL_NON_DYNAMIC_OBJECTS : Integer = $2; 
	 
	TA_PHYSICS_FLAG_GHOST_OBJECTS : Integer = $8; 
	TA_PHYSICS_FLAG_RENDER_COLLISIONS : Integer = $10; 
	 
	TA_PHYSICS_FLAG_SPACIAL_DIVISION_MASK : Integer = $20 + $40 + $80; 
	TA_PHYSICS_FLAG_XY_COLLISION_GRID : Integer = $20; 
	TA_PHYSICS_FLAG_XZ_COLLISION_GRID : Integer = $40; 
	TA_PHYSICS_FLAG_YZ_COLLISION_GRID : Integer = $60; 
	TA_PHYSICS_FLAG_DYNAMIC_OCTREE : Integer = $80; 

const
	TA_PHYSICS_SPACIAL_DIVISION_TYPE_DYNAMIC_OCTREE : Integer = 0; 
	TA_PHYSICS_SPACIAL_DIVISION_TYPE_XY_COLLISION_GRID : Integer = 1; 
	TA_PHYSICS_SPACIAL_DIVISION_TYPE_XZ_COLLISION_GRID : Integer = 2; 
	TA_PHYSICS_SPACIAL_DIVISION_TYPE_YZ_COLLISION_GRID : Integer = 3; 

procedure TaPhysics_CreateInstance(); stdcall;

procedure TaPhysics_DestroyInstance(); stdcall;

function TaPhysics_GetInstance() : PTaPhysics; stdcall;

procedure TaPhysics_SetupSimulation(
	pTaPhysics: PTaPhysics); stdcall;

procedure TaPhysics_Update(
	pTaPhysics: PTaPhysics;
	fDt : Single); stdcall;

procedure TaPhysics_Render(
	pTaPhysics: PTaPhysics); stdcall;

procedure TaPhysics_AddStaticObject(
	pTaPhysics: PTaPhysics;
	pStaticObject : PTaStaticObject); stdcall;

procedure TaPhysics_RemoveStaticObject(
	pTaPhysics: PTaPhysics;
	pStaticObject : PTaStaticObject); stdcall;

function TaPhysics_AddSurfaceAttribute(
	pTaPhysics: PTaPhysics;
	pSurfaceAttribute : PTaSurfaceAttribute) : Integer; stdcall;

function TaPhysics_AddSurfaceAttribute2(
	pTaPhysics: PTaPhysics) : Integer; stdcall;

procedure TaPhysics_RemoveSurfaceAttribute(
	pTaPhysics: PTaPhysics;
	nIndex : Integer); stdcall;

function TaPhysics_GetSurfaceAttribute(
	pTaPhysics: PTaPhysics;
	nIndex : Integer) : PTaSurfaceAttribute; stdcall;

function TaPhysics_GetNumSurfaceAttributes(
	pTaPhysics: PTaPhysics) : Integer; stdcall;

procedure TaPhysics_SetDefaultSurfaceAttribute(
	pTaPhysics: PTaPhysics;
	pSurfaceAttribute : PTaSurfaceAttribute); stdcall;

function TaPhysics_GetDefaultSurfaceAttribute(
	pTaPhysics: PTaPhysics) : PTaSurfaceAttribute; stdcall;

procedure TaPhysics_AddDynamicObject(
	pTaPhysics: PTaPhysics;
	pDynamicObject : PTaDynamicObject;
	bInitiallyMoving : TTaBool { default = true }); stdcall;

procedure TaPhysics_RemoveDynamicObject(
	pTaPhysics: PTaPhysics;
	pDynamicObject : PTaDynamicObject); stdcall;

procedure TaPhysics_SetDynamicObjectIsMoving(
	pTaPhysics: PTaPhysics;
	pDynamicObject : PTaDynamicObject); stdcall;

procedure TaPhysics_SetDynamicObjectAtRest(
	pTaPhysics: PTaPhysics;
	pDynamicObject : PTaDynamicObject); stdcall;

procedure TaPhysics_TestLineForCollision(
	pTaPhysics: PTaPhysics;
	var v3Start : TTaVec3;
	var v3Normal : TTaVec3;
	fLength : Single;
	collision : PTaCollision;
	nFlags : ta_u32); stdcall;

procedure TaPhysics_TestLineForCollision2(
	pTaPhysics: PTaPhysics;
	var v3Start : TTaVec3;
	var v3End : TTaVec3;
	collision : PTaCollision;
	nFlags : ta_u32 { default = FLAG_ALL_OBJECTS }); stdcall;

function TaPhysics_GetGravity(
	pTaPhysics: PTaPhysics) : PTaVec3; stdcall;

procedure TaPhysics_SetGravity(
	pTaPhysics: PTaPhysics;
	var v3Gravity : TTaVec3); stdcall;

procedure TaPhysics_SetRenderCollisionsEnabled(
	pTaPhysics: PTaPhysics;
	bValue : TTaBool); stdcall;

procedure TaPhysics_SetWorldDimensions(
	pTaPhysics: PTaPhysics;
	var worldAABB : TTaAABB); stdcall;

function TaPhysics_GetWorldDimensions(
	pTaPhysics: PTaPhysics) : PTaAABB; stdcall;

procedure TaPhysics_SetMaxNumCollisions(
	pTaPhysics: PTaPhysics;
	nMaxNumCollisions : Integer); stdcall;

function TaPhysics_GetMaxNumCollisions(
	pTaPhysics: PTaPhysics) : Integer; stdcall;

procedure TaPhysics_SetMaxNumMovingObjects(
	pTaPhysics: PTaPhysics;
	nMaxNumMovingObjects : Integer); stdcall;

function TaPhysics_GetMaxNumMovingObjects(
	pTaPhysics: PTaPhysics) : Integer; stdcall;

procedure TaPhysics_SetSlowSolverMaxNumCollisions(
	pTaPhysics: PTaPhysics;
	nSlowSolverMaxNumCollisions : Integer); stdcall;

function TaPhysics_GetSlowSolverMaxNumCollisions(
	pTaPhysics: PTaPhysics) : Integer; stdcall;

procedure TaPhysics_SetSlowSolverMaxNumObjects(
	pTaPhysics: PTaPhysics;
	nSlowSolverMaxNumObjects : Integer); stdcall;

function TaPhysics_GetSlowSolverMaxNumObjects(
	pTaPhysics: PTaPhysics) : Integer; stdcall;

procedure TaPhysics_SetMaxNumObjectPairs(
	pTaPhysics: PTaPhysics;
	nMaxNumObjectPairs : Integer); stdcall;

function TaPhysics_GetMaxNumObjectPairs(
	pTaPhysics: PTaPhysics) : Integer; stdcall;

procedure TaPhysics_SetSpacialDivisionType(
	pTaPhysics: PTaPhysics;
	eSpacialDivisionType : Integer); stdcall;

function TaPhysics_GetSpacialDivisionType(
	pTaPhysics: PTaPhysics) : Integer; stdcall;

procedure TaPhysics_SetSpacialDivisionMinSize(
	pTaPhysics: PTaPhysics;
	fSpacialDivisionMinSize : Single); stdcall;

function TaPhysics_GetSpacialDivisionMinSize(
	pTaPhysics: PTaPhysics) : Single; stdcall;

procedure TaPhysics_SetSpacialDivisionMaxMemory(
	pTaPhysics: PTaPhysics;
	nSpacialDivisionMaxMemory : Integer); stdcall;

function TaPhysics_GetSpacialDivisionMaxMemory(
	pTaPhysics: PTaPhysics) : Integer; stdcall;

function TaPhysics_GetDynamicVsDynamicCollisionTestCallBack(
	pTaPhysics: PTaPhysics) : TTaDynamicVsDynamicCollisionTestCallBack; stdcall;

procedure TaPhysics_SetDynamicVsDynamicCollisionTestCallBack(
	pTaPhysics: PTaPhysics;
	pFnDynamicVsDynamicCollisionTest : TTaDynamicVsDynamicCollisionTestCallBack); stdcall;

function TaPhysics_GetPreProcessCollisionCallBack(
	pTaPhysics: PTaPhysics) : TTaPreProcessCollisionCallBack; stdcall;

procedure TaPhysics_SetPreProcessCollisionCallBack(
	pTaPhysics: PTaPhysics;
	pFnPreProcessCollision : TTaPreProcessCollisionCallBack); stdcall;

function TaPhysics_GetPostProcessCollisionCallBack(
	pTaPhysics: PTaPhysics) : TTaPostProcessCollisionCallBack; stdcall;

procedure TaPhysics_SetPostProcessCollisionCallBack(
	pTaPhysics: PTaPhysics;
	pFnPostProcessCollision : TTaPostProcessCollisionCallBack); stdcall;

procedure TaPhysics_CreateInstance2(
	var worldAABB : TTaAABB;
	var v3Gravity : TTaVec3; { default = Vec3(0.0f, -9.81f, 0.0f) }
	nFlags : ta_u32; { default = FLAG_XZ_COLLISION_GRID }
	fMinSpacialDivision : Single; { default = 10.0f }
	nSpacialDivisionMemory : Integer { default = 0x40000 }); stdcall;

implementation

procedure TaPhysics_CreateInstance(); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_CreateInstance@0';

procedure TaPhysics_DestroyInstance(); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_DestroyInstance@0';

function TaPhysics_GetInstance() : PTaPhysics; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetInstance@0';

procedure TaPhysics_SetupSimulation(
	pTaPhysics: PTaPhysics); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetupSimulation@4';

procedure TaPhysics_Update(
	pTaPhysics: PTaPhysics;
	fDt : Single); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_Update@8';

procedure TaPhysics_Render(
	pTaPhysics: PTaPhysics); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_Render@4';

procedure TaPhysics_AddStaticObject(
	pTaPhysics: PTaPhysics;
	pStaticObject : PTaStaticObject); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_AddStaticObject@8';

procedure TaPhysics_RemoveStaticObject(
	pTaPhysics: PTaPhysics;
	pStaticObject : PTaStaticObject); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_RemoveStaticObject@8';

function TaPhysics_AddSurfaceAttribute(
	pTaPhysics: PTaPhysics;
	pSurfaceAttribute : PTaSurfaceAttribute) : Integer; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_AddSurfaceAttribute@8';

function TaPhysics_AddSurfaceAttribute2(
	pTaPhysics: PTaPhysics) : Integer; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_AddSurfaceAttribute2@4';

procedure TaPhysics_RemoveSurfaceAttribute(
	pTaPhysics: PTaPhysics;
	nIndex : Integer); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_RemoveSurfaceAttribute@8';

function TaPhysics_GetSurfaceAttribute(
	pTaPhysics: PTaPhysics;
	nIndex : Integer) : PTaSurfaceAttribute; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetSurfaceAttribute@8';

function TaPhysics_GetNumSurfaceAttributes(
	pTaPhysics: PTaPhysics) : Integer; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetNumSurfaceAttributes@4';

procedure TaPhysics_SetDefaultSurfaceAttribute(
	pTaPhysics: PTaPhysics;
	pSurfaceAttribute : PTaSurfaceAttribute); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetDefaultSurfaceAttribute@8';

function TaPhysics_GetDefaultSurfaceAttribute(
	pTaPhysics: PTaPhysics) : PTaSurfaceAttribute; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetDefaultSurfaceAttribute@4';

procedure TaPhysics_AddDynamicObject(
	pTaPhysics: PTaPhysics;
	pDynamicObject : PTaDynamicObject;
	bInitiallyMoving : TTaBool { default = true }); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_AddDynamicObject@12';

procedure TaPhysics_RemoveDynamicObject(
	pTaPhysics: PTaPhysics;
	pDynamicObject : PTaDynamicObject); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_RemoveDynamicObject@8';

procedure TaPhysics_SetDynamicObjectIsMoving(
	pTaPhysics: PTaPhysics;
	pDynamicObject : PTaDynamicObject); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetDynamicObjectIsMoving@8';

procedure TaPhysics_SetDynamicObjectAtRest(
	pTaPhysics: PTaPhysics;
	pDynamicObject : PTaDynamicObject); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetDynamicObjectAtRest@8';

procedure TaPhysics_TestLineForCollision(
	pTaPhysics: PTaPhysics;
	var v3Start : TTaVec3;
	var v3Normal : TTaVec3;
	fLength : Single;
	collision : PTaCollision;
	nFlags : ta_u32); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_TestLineForCollision@24';

procedure TaPhysics_TestLineForCollision2(
	pTaPhysics: PTaPhysics;
	var v3Start : TTaVec3;
	var v3End : TTaVec3;
	collision : PTaCollision;
	nFlags : ta_u32 { default = FLAG_ALL_OBJECTS }); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_TestLineForCollision2@20';

function TaPhysics_GetGravity(
	pTaPhysics: PTaPhysics) : PTaVec3; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetGravity@4';

procedure TaPhysics_SetGravity(
	pTaPhysics: PTaPhysics;
	var v3Gravity : TTaVec3); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetGravity@8';

procedure TaPhysics_SetRenderCollisionsEnabled(
	pTaPhysics: PTaPhysics;
	bValue : TTaBool); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetRenderCollisionsEnabled@8';

procedure TaPhysics_SetWorldDimensions(
	pTaPhysics: PTaPhysics;
	var worldAABB : TTaAABB); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetWorldDimensions@8';

function TaPhysics_GetWorldDimensions(
	pTaPhysics: PTaPhysics) : PTaAABB; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetWorldDimensions@4';

procedure TaPhysics_SetMaxNumCollisions(
	pTaPhysics: PTaPhysics;
	nMaxNumCollisions : Integer); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetMaxNumCollisions@8';

function TaPhysics_GetMaxNumCollisions(
	pTaPhysics: PTaPhysics) : Integer; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetMaxNumCollisions@4';

procedure TaPhysics_SetMaxNumMovingObjects(
	pTaPhysics: PTaPhysics;
	nMaxNumMovingObjects : Integer); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetMaxNumMovingObjects@8';

function TaPhysics_GetMaxNumMovingObjects(
	pTaPhysics: PTaPhysics) : Integer; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetMaxNumMovingObjects@4';

procedure TaPhysics_SetSlowSolverMaxNumCollisions(
	pTaPhysics: PTaPhysics;
	nSlowSolverMaxNumCollisions : Integer); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetSlowSolverMaxNumCollisions@8';

function TaPhysics_GetSlowSolverMaxNumCollisions(
	pTaPhysics: PTaPhysics) : Integer; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetSlowSolverMaxNumCollisions@4';

procedure TaPhysics_SetSlowSolverMaxNumObjects(
	pTaPhysics: PTaPhysics;
	nSlowSolverMaxNumObjects : Integer); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetSlowSolverMaxNumObjects@8';

function TaPhysics_GetSlowSolverMaxNumObjects(
	pTaPhysics: PTaPhysics) : Integer; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetSlowSolverMaxNumObjects@4';

procedure TaPhysics_SetMaxNumObjectPairs(
	pTaPhysics: PTaPhysics;
	nMaxNumObjectPairs : Integer); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetMaxNumObjectPairs@8';

function TaPhysics_GetMaxNumObjectPairs(
	pTaPhysics: PTaPhysics) : Integer; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetMaxNumObjectPairs@4';

procedure TaPhysics_SetSpacialDivisionType(
	pTaPhysics: PTaPhysics;
	eSpacialDivisionType : Integer); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetSpacialDivisionType@8';

function TaPhysics_GetSpacialDivisionType(
	pTaPhysics: PTaPhysics) : Integer; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetSpacialDivisionType@4';

procedure TaPhysics_SetSpacialDivisionMinSize(
	pTaPhysics: PTaPhysics;
	fSpacialDivisionMinSize : Single); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetSpacialDivisionMinSize@8';

function TaPhysics_GetSpacialDivisionMinSize(
	pTaPhysics: PTaPhysics) : Single; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetSpacialDivisionMinSize@4';

procedure TaPhysics_SetSpacialDivisionMaxMemory(
	pTaPhysics: PTaPhysics;
	nSpacialDivisionMaxMemory : Integer); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetSpacialDivisionMaxMemory@8';

function TaPhysics_GetSpacialDivisionMaxMemory(
	pTaPhysics: PTaPhysics) : Integer; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetSpacialDivisionMaxMemory@4';

function TaPhysics_GetDynamicVsDynamicCollisionTestCallBack(
	pTaPhysics: PTaPhysics) : TTaDynamicVsDynamicCollisionTestCallBack; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetDynamicVsDynamicCollisionTestCallBack@4';

procedure TaPhysics_SetDynamicVsDynamicCollisionTestCallBack(
	pTaPhysics: PTaPhysics;
	pFnDynamicVsDynamicCollisionTest : TTaDynamicVsDynamicCollisionTestCallBack); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetDynamicVsDynamicCollisionTestCallBack@8';

function TaPhysics_GetPreProcessCollisionCallBack(
	pTaPhysics: PTaPhysics) : TTaPreProcessCollisionCallBack; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetPreProcessCollisionCallBack@4';

procedure TaPhysics_SetPreProcessCollisionCallBack(
	pTaPhysics: PTaPhysics;
	pFnPreProcessCollision : TTaPreProcessCollisionCallBack); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetPreProcessCollisionCallBack@8';

function TaPhysics_GetPostProcessCollisionCallBack(
	pTaPhysics: PTaPhysics) : TTaPostProcessCollisionCallBack; stdcall;
external 'TaPhysics.dll' name '_TaPhysics_GetPostProcessCollisionCallBack@4';

procedure TaPhysics_SetPostProcessCollisionCallBack(
	pTaPhysics: PTaPhysics;
	pFnPostProcessCollision : TTaPostProcessCollisionCallBack); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_SetPostProcessCollisionCallBack@8';

procedure TaPhysics_CreateInstance2(
	var worldAABB : TTaAABB;
	var v3Gravity : TTaVec3; { default = Vec3(0.0f, -9.81f, 0.0f) }
	nFlags : ta_u32; { default = FLAG_XZ_COLLISION_GRID }
	fMinSpacialDivision : Single; { default = 10.0f }
	nSpacialDivisionMemory : Integer { default = 0x40000 }); stdcall;
external 'TaPhysics.dll' name '_TaPhysics_CreateInstance2@20';


end.
